package com.nineoldandroids_b4a.view;

import android.annotation.TargetApi;
import android.os.Build;
import android.view.View;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.ConcreteViewWrapper;
import static com.nineoldandroids_b4a.view.animation.AnimatorProxy.NEEDS_PROXY;
import static com.nineoldandroids_b4a.view.animation.AnimatorProxy.wrap;

@BA.ShortName(value = "noaViewHelper")
public final class ViewHelper {
	public ViewHelper() {}

	public static float getAlpha(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getAlpha() : Honeycomb.getAlpha(view.getObject());
	}

	public static void setAlpha(ConcreteViewWrapper view, float alpha) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setAlpha(alpha);
		} else {
			Honeycomb.setAlpha(view.getObject(), alpha);
		}
	}

	public static float getPivotX(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getPivotX() : Honeycomb.getPivotX(view.getObject());
	}

	public static void setPivotX(ConcreteViewWrapper view, float pivotX) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setPivotX(pivotX);
		} else {
			Honeycomb.setPivotX(view.getObject(), pivotX);
		}
	}

	public static float getPivotY(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getPivotY() : Honeycomb.getPivotY(view.getObject());
	}

	public static void setPivotY(ConcreteViewWrapper view, float pivotY) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setPivotY(pivotY);
		} else {
			Honeycomb.setPivotY(view.getObject(), pivotY);
		}
	}

	public static float getRotation(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getRotation() : Honeycomb.getRotation(view.getObject());
	}

	public static void setRotation(ConcreteViewWrapper view, float rotation) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setRotation(rotation);
		} else {
			Honeycomb.setRotation(view.getObject(), rotation);
		}
	}

	public static float getRotationX(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getRotationX() : Honeycomb.getRotationX(view.getObject());
	}

	public static void setRotationX(ConcreteViewWrapper view, float rotationX) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setRotationX(rotationX);
		} else {
			Honeycomb.setRotationX(view.getObject(), rotationX);
		}
	}

	public static float getRotationY(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getRotationY() : Honeycomb.getRotationY(view.getObject());
	}

	public static void setRotationY(ConcreteViewWrapper view, float rotationY) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setRotationY(rotationY);
		} else {
			Honeycomb.setRotationY(view.getObject(), rotationY);
		}
	}

	public static float getScaleX(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getScaleX() : Honeycomb.getScaleX(view.getObject());
	}

	public static void setScaleX(ConcreteViewWrapper view, float scaleX) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setScaleX(scaleX);
		} else {
			Honeycomb.setScaleX(view.getObject(), scaleX);
		}
	}

	public static float getScaleY(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getScaleY() : Honeycomb.getScaleY(view.getObject());
	}

	public static void setScaleY(ConcreteViewWrapper view, float scaleY) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setScaleY(scaleY);
		} else {
			Honeycomb.setScaleY(view.getObject(), scaleY);
		}
	}

	public static float getScrollX(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getScrollX() : Honeycomb.getScrollX(view.getObject());
	}

	public static void setScrollX(ConcreteViewWrapper view, int scrollX) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setScrollX(scrollX);
		} else {
			Honeycomb.setScrollX(view.getObject(), scrollX);
		}
	}

	public static float getScrollY(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getScrollY() : Honeycomb.getScrollY(view.getObject());
	}

	public static void setScrollY(ConcreteViewWrapper view, int scrollY) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setScrollY(scrollY);
		} else {
			Honeycomb.setScrollY(view.getObject(), scrollY);
		}
	}

	public static float getTranslationX(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getTranslationX() : Honeycomb.getTranslationX(view.getObject());
	}

	public static void setTranslationX(ConcreteViewWrapper view, float translationX) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setTranslationX(translationX);
		} else {
			Honeycomb.setTranslationX(view.getObject(), translationX);
		}
	}

	public static float getTranslationY(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getTranslationY() : Honeycomb.getTranslationY(view.getObject());
	}

	public static void setTranslationY(ConcreteViewWrapper view, float translationY) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setTranslationY(translationY);
		} else {
			Honeycomb.setTranslationY(view.getObject(), translationY);
		}
	}

	public static float getX(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getX() : Honeycomb.getX(view.getObject());
	}

	public static void setX(ConcreteViewWrapper view, float x) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setX(x);
		} else {
			Honeycomb.setX(view.getObject(), x);
		}
	}

	public static float getY(ConcreteViewWrapper view) {
		return NEEDS_PROXY ? wrap(view.getObject()).getY() : Honeycomb.getY(view.getObject());
	}

	public static void setY(ConcreteViewWrapper view, float y) {
		if (NEEDS_PROXY) {
			wrap(view.getObject()).setY(y);
		} else {
			Honeycomb.setY(view.getObject(), y);
		}
	}

	@TargetApi(Build.VERSION_CODES.HONEYCOMB)
	private static final class Honeycomb {
		static float getAlpha(View view) {
			return view.getAlpha();
		}

		static void setAlpha(View view, float alpha) {
			view.setAlpha(alpha);
		}

		static float getPivotX(View view) {
			return view.getPivotX();
		}

		static void setPivotX(View view, float pivotX) {
			view.setPivotX(pivotX);
		}

		static float getPivotY(View view) {
			return view.getPivotY();
		}

		static void setPivotY(View view, float pivotY) {
			view.setPivotY(pivotY);
		}

		static float getRotation(View view) {
			return view.getRotation();
		}

		static void setRotation(View view, float rotation) {
			view.setRotation(rotation);
		}

		static float getRotationX(View view) {
			return view.getRotationX();
		}

		static void setRotationX(View view, float rotationX) {
			view.setRotationX(rotationX);
		}

		static float getRotationY(View view) {
			return view.getRotationY();
		}

		static void setRotationY(View view, float rotationY) {
			view.setRotationY(rotationY);
		}

		static float getScaleX(View view) {
			return view.getScaleX();
		}

		static void setScaleX(View view, float scaleX) {
			view.setScaleX(scaleX);
		}

		static float getScaleY(View view) {
			return view.getScaleY();
		}

		static void setScaleY(View view, float scaleY) {
			view.setScaleY(scaleY);
		}

		static float getScrollX(View view) {
			return view.getScrollX();
		}

		@TargetApi(Build.VERSION_CODES.ICE_CREAM_SANDWICH)
		static void setScrollX(View view, int scrollX) {
			view.setScrollX(scrollX);
		}

		static float getScrollY(View view) {
			return view.getScrollY();
		}

		@TargetApi(Build.VERSION_CODES.ICE_CREAM_SANDWICH)
		static void setScrollY(View view, int scrollY) {
			view.setScrollY(scrollY);
		}

		static float getTranslationX(View view) {
			return view.getTranslationX();
		}

		static void setTranslationX(View view, float translationX) {
			view.setTranslationX(translationX);
		}

		static float getTranslationY(View view) {
			return view.getTranslationY();
		}

		static void setTranslationY(View view, float translationY) {
			view.setTranslationY(translationY);
		}

		static float getX(View view) {
			return view.getX();
		}

		static void setX(View view, float x) {
			view.setX(x);
		}

		static float getY(View view) {
			return view.getY();
		}

		static void setY(View view, float y) {
			view.setY(y);
		}
	}
}
